package com.ruoyi.api.labour.domain;

import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * 劳务人员签名推送信息 请求参数
 *
 * @author: JiangYuQi
 * @date: 2024/01/13 12:21
 */
@Data
public class LabourSignetVo {

    /**
     * 签名
     * RSA(用户账号 + 时间戳)加密
     */
    @NotBlank(message = "签名不能为空")
    private String sign;

    /**
     * 时间戳
     */
    @NotNull(message = "时间戳不能为空")
    private Long timestamp;

    /**
     * 效验时间签名
     */
    public Boolean checkTimestamp() {
        boolean timestampFlag = false;
        long timePoor = Math.abs(timestamp - System.currentTimeMillis());
        if (timePoor < 1000 * 60 * 3) {
            timestampFlag = true;
        }
        return timestampFlag;
    }
}
